Subject: Re: bug#26126: 26.0.50; file-notify-rm-watch removes arbitrary watches

From: Eli Zaretskii <[email-masked]>
Date: Sat, 25 Mar 2017 09:35:53 +0300

> From: Andreas Politz <[email-masked]>
> Date: Fri, 24 Mar 2017 21:44:28 +0100
> Cc: [email-masked]
> 
> I also thought about the test-cases and more generally about how to
> develop a specification for this library, i.e. how do we want this to
> behave.  Do we have the desire that it works uniformly across all
> participating back-ends ?

In general, yes.

> And is that even possible ?

Almost.  Some corner cases (like what happens when the watched
directory is deleted) behave differently.

> One way to go about this would be to write a series of definitive
> unit-tests which specify the intended behavior. Then, allow them to fail
> for a specific back-end, until someone has fixed potential bugs for it
> and confirmed that the test succeeds.

That's how these tests were developed.  What you see is the result; if
you have specific comments about some known failures, please spell
them out.

> Anyway, I was bored today, so I took a look at what events these
> libraries actually produce, the result of which you may also find below.

Thanks, but I have difficulty reading it.  Could you please provide a
short legend?

> Finally, I'm tempted to suggest to get rid of the flags argument of
> file-notify-add-watch.  As it is, things are already complicated enough
> and we don't seem to have many people working on this.  I think we could
> make it backward-compatible to a certain degree.  Note also, that many
> file operations trigger both kinds of events anyway.

The flags are there for the operations where the differences matter.